// let's get grabby

function Player::canGrab(%this, %object) {
  if (!$Pref::Server::PlayerThrowing::Enabled || !isObject(%object)) {
    return false;
  }

  if (%object.getClassName() !$= "Player" || %object.isDisabled()) {
    return false;
  }

  if (!isObject(%client = %this.client) || %client.grabbingDisabled) {
    return false;
  }

  if (!isObject(%targetClient = %object.client) || %targetClient.unholdable) {
    return false;
  }

  if (isObject(%targetClient.miniGame)) {
    if (!%targetClient.miniGame.WeaponDamage || %targetClient.miniGame != %client.miniGame) {
      return false;
    }
  }

  if (isObject(%client.miniGame)) {
    if (!%client.miniGame.WeaponDamage || %targetClient.miniGame != %client.miniGame) {
      return false;
    }
  }

  if (miniGameCanDamage(%this, %object) != 1 && $Pref::Server::PlayerThrowing::MiniGameOnly) {
    return false;
  }

  if (%object.isBeingHeld()) {
    return false;
  }

  return true;
}

function Player::attemptGrab(%this) {
  %timeoutMS = $Pref::Server::PlayerThrowing::GrabTimeout * 1000;
  %timeDiff = getSimTime() - %this.grabTimeout;

  if (%timeDiff < %timeoutMS) {
    return false;
  }

  %zScale = getWord(%this.getScale(), 2);
  %start = %this.getEyePoint();
  %vector = %this.getEyeVector();
  %end = vectorAdd(%start, vectorScale(%vector, 2 * %zScale));
  
  %ray = containerRaycast(%start, %end, $TypeMasks::PlayerObjectType, %this);
  %col = firstWord(%ray);

  if (!%this.canGrab(%col)) {
    return false;
  }

  if (!isObject(%client = %col.client)) {
    return false;
  }

  if (%col.isMounted()) {
    %col.dismount();
  }

  %col.oldScale = %col.getScale();

  %col.unmountImage(0);
  %col.canDismount = false;
  %this.mountObject(%col, 0);

  %newScale = vectorScale(%this.getScale(), 0.8);

  %col.setScale(%newScale);
  %col.playThread(1, death1);
  %col.setTransform(%col.getPosition() @ " 0 0 0.85 90");
  %col.setLookLimits(0.7, 0.5);
  
  %client.camera.setMode("Grabbed");
  %client.camera.setOrbitMode(%this, 0, 5, 10, 5, 0);
  %client.setControlObject(%client.camera);

  %this.playThread(0, armReadyBoth);

  %col.holderPlayer = %this;
  %col.lastTimeGrabbed = getSimTime();
  %this.holdingPlayer = %col;
  %this.grabTimeout = getSimTime();

  return true;
}

function Player::isHoldingPlayer(%this) {
  return isObject(%this.holdingPlayer);
}

function Player::isBeingHeld(%this) {
  return isObject(%this.holderPlayer);
}
