package Script_PlayerThrowing {

  function Armor::onTrigger(%this, %obj, %triggerNum, %val) {

    if (%triggerNum == 0 && %obj.isHoldingPlayer()) {

      if (%val == 1) {

        if ($Pref::Server::PlayerThrowing::ChargeThrow) {
          %obj.chargeThrow();
          return;
        }
        else {
          %obj.throwPlayer($Pref::Server::PlayerThrowing::ThrowAmount);
          return;
        }

      }
      else if (%obj.chargeThrowAmount > 0) {
        %obj.throwPlayer(%obj.chargeThrowAmount);
        return;
      }
    }

    Parent::onTrigger(%this, %obj, %triggerNum, %val);
  }

  function Player::activateStuff(%this) {
    if (%this.isBeingHeld()) {
      if (%this.escapeFromGrasp()) {
        return;
      }
      else {
        return Parent::activateStuff(%this);
      }
    }

    if (%this.isHoldingPlayer()) {
      return;
    }

    if (%this.attemptGrab()) {
      return;
    }

    return Parent::activateStuff(%this);
  }

  function Observer::onTrigger(%this, %obj, %trigger, %state) {
    %client = %obj.getControllingClient();

    if (%obj.mode !$= "Grabbed" || !isObject(%client)) {
      Parent::onTrigger(%this, %obj, %trigger, %state);
      return;
    }

    if (!isObject(%player = %client.player)) {
      Parent::onTrigger(%this, %obj, %trigger, %state);
      return;
    }

    if (%trigger == 0 && %state == 1) {
      %player.escapeFromGrasp();
    }
  }

  function Armor::onRemove(%this, %obj) {
    %obj.clearAllHolding();
    Parent::onRemove(%this, %obj);
  }

  function GameConnection::onDeath(%this, %killerPlayer, %killerClient, %damageType, %damageLoc) {
    if (isObject(%player = %this.player) && %player.getClassName() $= "Player") {
      %player.clearAllHolding();
    }

    Parent::onDeath(%this, %killerPlayer, %killerClient, %damageType, %damageLoc);
  }

  function serverCmdUseInventory(%client, %slot) {
    if (PlayerThrowing_CanUseTools(%client)) {
      Parent::serverCmdUseInventory(%client, %slot);
    }
  }

  function serverCmdUseSprayCan(%client, %slot) {
    if (PlayerThrowing_CanUseTools(%client)) {
      Parent::serverCmdUseSprayCan(%client, %slot);
    }
  }

  function serverCmdUseFxCan(%client, %slot) {
    if (PlayerThrowing_CanUseTools(%client)) {
      Parent::serverCmdUseFxCan(%client, %slot);
    }
  }

  function serverCmdUseTool(%client, %slot) {
    if (PlayerThrowing_CanUseTools(%client)) {
      Parent::serverCmdUseTool(%client, %slot);
    }
  }

  function serverCmdUnuseTool(%client) {
    if (PlayerThrowing_CanUseTools(%client)) {
      Parent::serverCmdUnuseTool(%client);
    }
  }

  function serverCmdInstantUseBrick(%client, %data) {
    if (PlayerThrowing_CanUseTools(%client)) {
      Parent::serverCmdInstantUseBrick(%client, %data);
    }
  }
};
activatePackage(Script_PlayerThrowing);
